package com.muzhi.meixi.controller;

import com.muzhi.meixi.common.R;
import com.muzhi.meixi.service.DingOaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;


@Api(description = "钉钉")
@RestController
@RequestMapping("/dingservice")
@CrossOrigin//解决跨域问题
public class DingOaController {

    @Autowired
    private DingOaService dingOaService;

    //获取旺店通库存信息
    @ApiOperation(value = "获取旺店通库存信息")
    @GetMapping("getWangdiantongStocks")
//    @Scheduled(cron = "0 10 0 * * ?")//每天00：10触发（也就是凌晨0点10分触发）
//    @Scheduled(cron = "0 0/10 * * * ?")//每10分钟执行一次
    @Scheduled(cron = "0 */10 * * * ?")//每隔10分钟执行一次
    public String getWangdiantongStocks(){
        //先删除清空Stocks表
        dingOaService.removeStocks();

        String wangdiantongStocks = dingOaService.getWangdiantongStocks();
        return wangdiantongStocks;
    }

    //旺店通库存信息表同步展示表
//    @ApiOperation(value = "获取旺店通库存信息")
//    @GetMapping("setStocksCopy")
//    @Scheduled(cron = "0 35 0 * * ?")//每天00：35触发（也就是凌晨0点35分触发）
//    public String setStocksCopy(){
//
//        String setStocksCopy = dingOaService.setStocksCopy();
//        return setStocksCopy;
//    }

    //获取旺店通库存信息，并同步至宜搭
//    @ApiOperation(value = "获取旺店通库存信息，并同步至宜搭")
//    @PostMapping("createWangdiantongStocks")
//    @Scheduled(cron = "0 5 1 * * ?")//每天01：05触发（也就是凌晨1点05分触发）
//    public String createWangdiantongStocks(){
//
//        String wangdiantongStocks = dingOaService.createWangdiantongStocks();
//        return wangdiantongStocks;
//    }
}