package com.muzhi.meixi.service.impl;


import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.dingtalkworkflow_1_0.models.GetProcessInstanceResponse;
import com.aliyun.dingtalkworkflow_1_0.models.ListProcessInstanceIdsResponse;
import com.aliyun.dingtalkyida_1_0.models.SearchFormDatasResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muzhi.meixi.api.WdtClient;
import com.muzhi.meixi.entity.Stocks;
import com.muzhi.meixi.entity.StocksCopy;
import com.muzhi.meixi.mapper.StocksCopyMapper;
import com.muzhi.meixi.mapper.StocksMapper;
import com.muzhi.meixi.service.AccessTokenService;
import com.muzhi.meixi.service.DingOaService;
import lombok.extern.log4j.Log4j;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;


@Service
@Slf4j
public class DingOaServiceImpl implements DingOaService {

    @Autowired
    private AccessTokenService accessTokenService;

    //旺店通同步库存
    @Autowired
    private StocksMapper stocksMapper;

    //宜搭展示库存表
    @Autowired
    private StocksCopyMapper stocksCopyMapper;



    //删除旺店通同步库存表中的所有数据
    @Override
    public String removeStocks(){
        stocksMapper.delete(null);
        return "清空旺店通同步库存数据成功！";
    }

    //删除宜搭展示库存表
//    @Override
//    public String removeStocksCopy(){
//        stocksCopyMapper.delete(null);
//        return "清空旺店通同步库存数据成功！";
//    }



    //获取旺店通库存信息
    @Override
    public String getWangdiantongStocks(){
//        //卖家账号
//        String sidTest = "apidevnew2";
//        //接口账号
//        String appkeyTest = "xindi2-test";
//        //接口秘钥
//        String appsecretTest = "bff3980d2";
//        //测试环境
//        String baseUrlTest = "https://sandbox.wangdian.cn/openapi2/";

//        //测试
//        WdtClient client = new WdtClient(sidTest, appkeyTest, appsecretTest, baseUrlTest);

        //卖家账号
        String sid = "xindi2";
        //接口账号
        String appkey = "xindi2-ot";
        //接口秘钥
        String appsecret = "7aaa92c1cb4b8c00d42082b5d430c55a";
        //正式环境
        String baseUrl = "https://api.wangdian.cn/openapi2/";

        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //获取当前时间时分秒
        Date Date = new Date(System.currentTimeMillis());
        System.out.println("当前时间：" + Date);
        String dateNowString = simpleDateFormat.format(Date);
        System.out.println("当前时间（时间样式）：" + dateNowString);

        //获取前一天的零点零分零秒
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(Date);
        //前一天
        calendar.add(Calendar.DAY_OF_MONTH,-1);
        calendar.set(Calendar.HOUR_OF_DAY,0);
        calendar.set(Calendar.MINUTE,0);
        calendar.set(Calendar.SECOND,0);
        calendar.set(Calendar.MILLISECOND,0);
        String time = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(calendar.getTime());
        System.out.println("前一天零点（时间样式）：" + time);

        List list = new ArrayList();
        list.add("048");//奇门菜鸟仓
        list.add("020");//天猫仓
        list.add("021");//网红仓
        list.add("022");//分销仓
        list.add("023");//备用仓
//        list.add("024");//次品仓
//        list.add("025");//徐汇仓
        list.add("026");//广州仓
        list.add("033");//直营仓
//        list.add("059");//广州次品仓
//        list.add("060");//暂存仓
        for (int a = 0; a < list.size(); a++) {
            String warehouseId = list.get(a).toString();
            log.info("=========当前查询仓库编号=========：" + warehouseId);
            System.out.println("=========当前仓库编号=========：" + warehouseId);

            //休眠时间
            final long timeInterval = 800;

            String page_no = "0";
            String page_size = "100";

            JSONArray stocksArray = null;
            try {
                do {
                    //正式
                    WdtClient client = new WdtClient(sid, appkey, appsecret, baseUrl);

                    //测试环境sid、appkey、密钥请到旺店通开放平台-自助对接-申请测试环境内查看，测试环境url=https://sandbox.wangdian.cn/openapi2/
                    //调用正式环境时请将sid、appkey、appsecret切换为实际参数，参数在旺店通开放平台-自助对接-应用管理内应用状态为已上线的应用中查看，调用正式环境注意切换正式环境url=https://api.wangdian.cn/openapi2/

                    System.out.println("当前分页数：" + page_no);

                    Map<String, String> params = new HashMap<>();
                    //【全量查询库存接口】
//                    params.put("warehouse_no", warehouseId);
////                    params.put("start_time","2022-11-01 00:00:00");
////                    params.put("end_time","2022-11-29 00:00:00");
//                    params.put("page_no", page_no);
//                    params.put("page_size", page_size);
//
//                    JSONObject jsonObject = null;
//                    try {
//                        String response = client.execute("vip_stock_query_all.php", params);
//                        System.out.println("分页【" + page_no + "】调用返回数据" + response);
//
//                        jsonObject = JSON.parseObject(response);
//
//                    } catch (IOException e) {
//                        e.printStackTrace();
//                    }

                    //【增量查询库存接口】
                    //仓库编号
                    params.put("warehouse_no", warehouseId);
                    //商家编码
//                    params.put("spec_no","xindi2");
                    //已删除货品库存信息（1代表查询未删除库存，不传或者传0查询所有库存）
                    params.put("is_deleted","1");
//                    params.put("start_time","2020-07-01 00:00:00");
//                    params.put("end_time","2020-07-31 00:00:00");
                    //开始时间（前一天时间）
                    params.put("start_time",time);
                    //结束时间（当前时间）
                    params.put("end_time",dateNowString);
                    params.put("page_no", page_no);
                    params.put("page_size", page_size);

                    JSONObject jsonObject = null;
                    try {
                        String response = client.execute("stock_query.php", params);
                        System.out.println("分页【" + page_no + "】调用返回数据" + response);

                        jsonObject = JSON.parseObject(response);

                    } catch (IOException e) {
                        e.printStackTrace();
                    }

//            String total_count = jsonObject.getString("total_count");
//            int total_countAll = Integer.parseInt(total_count);
//            System.out.println("总数：" + total_countAll);
//            int page_noAll = total_countAll/100;
//            System.out.println("总页数：" + page_noAll);

                    Stocks stocks = new Stocks();
                    stocksArray = jsonObject.getJSONArray("stocks");
                for (int i = 0; i < stocksArray.size(); i++) {
                    JSONObject jsonObject1 = stocksArray.getJSONObject(i);
                    //条形码
                    String barcode = jsonObject1.getString("barcode");
                    stocks.setBarcode(barcode);
                    //货品编码
                    String goods_no = jsonObject1.getString("goods_no");
                    stocks.setGoodsNo(goods_no);
                    //货品名称
                    String goods_name = jsonObject1.getString("goods_name");
                    stocks.setGoodsName(goods_name);
                    //仓库主键id
                    String warehouse_id = jsonObject1.getString("warehouse_id");
                    stocks.setWarehouseId(warehouse_id);
                    //仓库编码
                    String warehouse_no = jsonObject1.getString("warehouse_no");
                    stocks.setWarehouseNo(warehouse_no);
                    //仓库名称
                    String warehouse_name = jsonObject1.getString("warehouse_name");
                    stocks.setWarehouseName(warehouse_name);
//                    //库存量
//                    Float stock_num = jsonObject1.getFloat("stock_num");
//                    stocks.setStockNum(stock_num);
                    //可发库存
                    Float stock_num = jsonObject1.getFloat("avaliable_num");
                    stocks.setStockNum(stock_num);

                    stocksMapper.insert(stocks);
                }

                    int page_noINT = Integer.parseInt(page_no);
                    page_noINT = page_noINT + 1;
                    page_no = String.valueOf(page_noINT);

                    //休眠3秒钟再次调用：由于旺店通接口1分钟只能调用60次接口
                    Thread.sleep(timeInterval);
                    log.info("休眠中......");

                }while (!stocksArray.isEmpty() & stocksArray.size() == 100);

            }catch (InterruptedException e){
                e.printStackTrace();
            }
        }
//        log.info("======&&&&&&******【旺店通库存表数据同步结束】******&&&&&&======");
//        return "旺店通库存信息同步至数据库成功！";

        /*旺店通库存同步完成后调用该方法同步至展示表*/
        log.info("开始调用同步展示表方法......");
        setStocksCopy();
        log.info("===同步展示表方法结束===");

        /*更新宜搭库存表*/
        log.info("开始调用更新宜搭库存表方法......");
        createWangdiantongStocks();
        log.info("===同步宜搭库存表方法结束===");

        log.info("======&&&&&&******【旺店通库存表同步宜搭结束】******&&&&&&======");
        return "旺店通库存表同步宜搭结束！";
    }

    //旺店通库存信息表同步展示表
    @Override
    public String setStocksCopy(){

//        //本月剩余天数
//        Calendar calendar = Calendar.getInstance(TimeZone.getTimeZone("GMT+08:OO"));
//        int days = calendar.get(Calendar.DAY_OF_MONTH);
//        System.out.println("本月当前天数：" + days);
//        int MaxDays = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
//        System.out.println("本月最大天数：" + MaxDays);
//        //+1的目的是为了将当天也包含在本月剩余天数中
//        int bysyts = MaxDays - days + 1;
//        System.out.println("本月剩余天数：" + bysyts);
//
//        //下月总天数
//        calendar.add(Calendar.MONTH,+1);//下个月
//        int xyzts = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
//        System.out.println("下月总天数：" + xyzts);

        //TODO test
//        QueryWrapper<Stocks> queryWrapperTest = new QueryWrapper<>();
//        queryWrapperTest.eq("goods_no", "LC106CN");


        //抓取旺店通库存表数据
        List<Stocks> stocksList = stocksMapper.selectList(null);
        System.out.println("旺店通数据表总数：" + stocksList.size());

        //循环获取旺店通库存表数据
        for (int x = 0; x < stocksList.size(); x++) {
            //创建展示表
            StocksCopy stocksCopy = new StocksCopy();

//            log.info("******当前条数======：" + x);
            //条形码
            String barcode = stocksList.get(x).getBarcode();
//            log.info("******条形码======：" + barcode);
            //货品编码
            String goodsNo = stocksList.get(x).getGoodsNo();
//            log.info("******货品编码======：" + goodsNo);
            //货品名称
            String goodsName = stocksList.get(x).getGoodsName();
//            log.info("******货品名称======：" + goodsName);
            //仓库编码
            String warehouseNo = stocksList.get(x).getWarehouseNo();
//            log.info("******仓库编码======：" + warehouseNo);
            //仓库名称
            String warehouseName = stocksList.get(x).getWarehouseName();
//            log.info("******仓库名称======：" + warehouseName);
            //仓库数量
            float stockNum = stocksList.get(x).getStockNum();
//            log.info("******仓库数量======：" + stockNum);

            /*查询数据库中Copy表是否存在物品的id*/
            String wpid = null;
            QueryWrapper<StocksCopy> queryWrapper = new QueryWrapper<>();
            try {
                queryWrapper.eq("goods_no", goodsNo);

                wpid = stocksCopyMapper.selectOne(queryWrapper).getGoodsNo();
            }catch (Exception e){
                e.printStackTrace();
            }
            System.out.println("查询数据库中Copy表是否存在物品的id：" + wpid);
            /*查询数据库中Copy表是否存在物品的id*/

            //判断展示表中是否存在当前物品编码
            if (wpid == null){
                log.info("展示表当前物品为空，开始执行插入......");

                //条形码
                stocksCopy.setBarcode(barcode);
                System.out.println("插入条码：" + barcode);
                //货品编码
                stocksCopy.setGoodsNo(goodsNo);
                System.out.println("插入货品编码：" + goodsNo);
                //货品名称
                stocksCopy.setGoodsName(goodsName);
                System.out.println("插入货品名称：" + goodsName);

//                //本月剩余天数
//                stocksCopy.setBysyts(bysyts);
//                System.out.println("插入本月剩余天数：" + bysyts);
//                //下月总天数
//                stocksCopy.setXyzts(xyzts);
//                System.out.println("插入下月总天数：" + xyzts);

                System.out.println("仓库编码：" + warehouseNo);
                //仓库编码/仓库名称/仓库数量
                if (warehouseNo.equals("048")){//奇门菜鸟仓
                    stocksCopy.setQmcncNo(warehouseNo);
                    stocksCopy.setQmcncName(warehouseName);
                    stocksCopy.setQmcncNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("048仓库数量：" + stockNum);
                }
                else if (warehouseNo.equals("020")){//天猫仓
                    stocksCopy.setTmcNo(warehouseNo);
                    stocksCopy.setTmcName(warehouseName);
                    stocksCopy.setTmcNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("020仓库数量：" + stockNum);
                }
                else if (warehouseNo.equals("021")){//网红仓
                    stocksCopy.setWhcNo(warehouseNo);
                    stocksCopy.setWhcName(warehouseName);
                    stocksCopy.setWhcNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("021仓库数量：" + stockNum);
                }
                else if (warehouseNo.equals("022")){//分销仓
                    stocksCopy.setFxcNo(warehouseNo);
                    stocksCopy.setFxcName(warehouseName);
                    stocksCopy.setFxcNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("022仓库数量：" + stockNum);
                }
                else if (warehouseNo.equals("023")){//备用仓
                    stocksCopy.setBycNo(warehouseNo);
                    stocksCopy.setBycName(warehouseName);
                    stocksCopy.setBycNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("023仓库数量：" + stockNum);
                }
//                else if (warehouseNo.equals("024")){//次品仓
//                    stocksCopy.setCpcNo(warehouseNo);
//                    stocksCopy.setCpcName(warehouseName);
//                    stocksCopy.setCpcNum(stockNum);
//
//                    //国内加总
//                    stocksCopy.setGnjz(stockNum);
//                    System.out.println("024仓库数量：" + stockNum);
//                }
//                else if (warehouseNo.equals("025")){//徐汇仓
//                    stocksCopy.setXhcNo(warehouseNo);
//                    stocksCopy.setXhcName(warehouseName);
//                    stocksCopy.setXhcNum(stockNum);
//
//                    //国内加总
//                    stocksCopy.setGnjz(stockNum);
//                    System.out.println("025仓库数量：" + stockNum);
//                }
                else if (warehouseNo.equals("026")){//广州仓
                    stocksCopy.setGzcNo(warehouseNo);
                    stocksCopy.setGzcName(warehouseName);
                    stocksCopy.setGzcNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("026仓库数量：" + stockNum);
                }
                else if (warehouseNo.equals("033")){//直营仓
                    stocksCopy.setZycNo(warehouseNo);
                    stocksCopy.setZycName(warehouseName);
                    stocksCopy.setZycNum(stockNum);

                    //国内加总
                    stocksCopy.setGnjz(stockNum);
                    System.out.println("033仓库数量：" + stockNum);
                }
//                else if (warehouseNo.equals("059")){//广州次品仓
//                    stocksCopy.setGzcpcNo(warehouseNo);
//                    stocksCopy.setGzcpcName(warehouseName);
//                    stocksCopy.setGzcpcNum(stockNum);
//
//                    //国内加总
//                    stocksCopy.setGnjz(stockNum);
//                    System.out.println("059仓库数量：" + stockNum);
//                }
//                else if (warehouseNo.equals("060")){//暂存仓
//                    stocksCopy.setZccNo(warehouseNo);
//                    stocksCopy.setZccName(warehouseName);
//                    stocksCopy.setZccNum(stockNum);
//
//                    //国内加总
//                    stocksCopy.setGnjz(stockNum);
//                    System.out.println("060仓库数量：" + stockNum);
//                }
                //展示表不存在该物品则新增一条
                stocksCopyMapper.insert(stocksCopy);
            }
            else if (wpid != null){
                log.info("展示表当前物品不为空，开始执行更新......");

                log.info("******当前条数======：" + x);
                //条形码
//                String barcode = stocksList.get(x).getBarcode();
                log.info("******条形码======：" + barcode);
                //货品编码
//                String goodsNo = stocksList.get(x).getGoodsNo();
                log.info("******货品编码======：" + goodsNo);
                //货品名称
//                String goodsName = stocksList.get(x).getGoodsName();
                log.info("******货品名称======：" + goodsName);
                //仓库编码
//                String warehouseNo = stocksList.get(x).getWarehouseNo();
                log.info("******仓库编码======：" + warehouseNo);
                //仓库名称
//                String warehouseName = stocksList.get(x).getWarehouseName();
                log.info("******仓库名称======：" + warehouseName);
                //仓库数量
//                float stockNum = stocksList.get(x).getStockNum();
                log.info("******仓库数量======：" + stockNum);

                UpdateWrapper<StocksCopy> updateWrapper = new UpdateWrapper<>();
                updateWrapper.eq("goods_no",wpid);

//                //本月剩余天数
//                updateWrapper.set("bysyts",bysyts);
//                System.out.println("更新本月剩余天数：" + bysyts);
//                //下月总天数
//                updateWrapper.set("xyzts",xyzts);
//                System.out.println("更新下月总天数：" + xyzts);

                //仓库编码/仓库名称/仓库数量
                if (warehouseNo.equals("048")){//奇门菜鸟仓
                    stocksCopy.setQmcncNo(warehouseNo);
                    stocksCopy.setQmcncName(warehouseName);
                    stocksCopy.setQmcncNum(stockNum);

                    updateWrapper.set("qmcnc_no",warehouseNo);
                    updateWrapper.set("qmcnc_name",warehouseName);
                    updateWrapper.set("qmcnc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【048奇门菜鸟仓】数据到这！***");
                }
                else if (warehouseNo.equals("020")){//天猫仓
                    stocksCopy.setTmcNo(warehouseNo);
                    stocksCopy.setTmcName(warehouseName);
                    stocksCopy.setTmcNum(stockNum);

                    updateWrapper.set("tmc_no",warehouseNo);
                    updateWrapper.set("tmc_name",warehouseName);
                    updateWrapper.set("tmc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【020天猫仓】数据到这！***");
                }
                else if (warehouseNo.equals("021")){//网红仓
                    stocksCopy.setWhcNo(warehouseNo);
                    stocksCopy.setWhcName(warehouseName);
                    stocksCopy.setWhcNum(stockNum);

                    updateWrapper.set("whc_no",warehouseNo);
                    updateWrapper.set("whc_name",warehouseName);
                    updateWrapper.set("whc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【021网红仓】数据到这！***");
                }
                else if (warehouseNo.equals("022")){//分销仓
                    stocksCopy.setFxcNo(warehouseNo);
                    stocksCopy.setFxcName(warehouseName);
                    stocksCopy.setFxcNum(stockNum);

                    updateWrapper.set("fxc_no",warehouseNo);
                    updateWrapper.set("fxc_name",warehouseName);
                    updateWrapper.set("fxc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【022分销仓】数据到这！***");
                }
                else if (warehouseNo.equals("023")){//备用仓
                    stocksCopy.setBycNo(warehouseNo);
                    stocksCopy.setBycName(warehouseName);
                    stocksCopy.setBycNum(stockNum);

                    updateWrapper.set("byc_no",warehouseNo);
                    updateWrapper.set("byc_name",warehouseName);
                    updateWrapper.set("byc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【023备用仓】数据到这！***");
                }
//                else if (warehouseNo.equals("024")){//次品仓
//                    stocksCopy.setCpcNo(warehouseNo);
//                    stocksCopy.setCpcName(warehouseName);
//                    stocksCopy.setCpcNum(stockNum);
//
//                    updateWrapper.set("cpc_no",warehouseNo);
//                    updateWrapper.set("cpc_name",warehouseName);
//                    updateWrapper.set("cpc_num",stockNum);
////                    //国内加总
////                    stocksCopy.setGnjz(stockNumAll);
//                    log.info("***【024次品仓】数据到这！***");
//                }
//                else if (warehouseNo.equals("025")){//徐汇仓
//                    stocksCopy.setXhcNo(warehouseNo);
//                    stocksCopy.setXhcName(warehouseName);
//                    stocksCopy.setXhcNum(stockNum);
//
//                    updateWrapper.set("xhc_no",warehouseNo);
//                    updateWrapper.set("xhc_name",warehouseName);
//                    updateWrapper.set("xhc_num",stockNum);
////                    //国内加总
////                    stocksCopy.setGnjz(stockNumAll);
//                    log.info("***【025徐汇仓】数据到这！***");
//                }
                else if (warehouseNo.equals("026")){//广州仓
                    stocksCopy.setGzcNo(warehouseNo);
                    stocksCopy.setGzcName(warehouseName);
                    stocksCopy.setGzcNum(stockNum);

                    updateWrapper.set("gzc_no",warehouseNo);
                    updateWrapper.set("gzc_name",warehouseName);
                    updateWrapper.set("gzc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【026广州仓】数据到这！***");
                }
                else if (warehouseNo.equals("033")){//直营仓
                    stocksCopy.setZycNo(warehouseNo);
                    stocksCopy.setZycName(warehouseName);
                    stocksCopy.setZycNum(stockNum);

                    updateWrapper.set("zyc_no",warehouseNo);
                    updateWrapper.set("zyc_name",warehouseName);
                    updateWrapper.set("zyc_num",stockNum);
//                    //国内加总
//                    stocksCopy.setGnjz(stockNumAll);
                    log.info("***【033直营仓】数据到这！***");
                }
//                else if (warehouseNo.equals("059")){//广州次品仓
//                    stocksCopy.setGzcpcNo(warehouseNo);
//                    stocksCopy.setGzcpcName(warehouseName);
//                    stocksCopy.setGzcpcNum(stockNum);
//
//                    updateWrapper.set("gzcpc_no",warehouseNo);
//                    updateWrapper.set("gzcpc_name",warehouseName);
//                    updateWrapper.set("gzcpc_num",stockNum);
////                    //国内加总
////                    stocksCopy.setGnjz(stockNumAll);
//                    log.info("***【059广州次品仓】数据到这！***");
//                }
//                else if (warehouseNo.equals("060")){//暂存仓
//                    stocksCopy.setZccNo(warehouseNo);
//                    stocksCopy.setZccName(warehouseName);
//                    stocksCopy.setZccNum(stockNum);
//
//                    updateWrapper.set("zcc_no",warehouseNo);
//                    updateWrapper.set("zcc_name",warehouseName);
//                    updateWrapper.set("zcc_num",stockNum);
////                    //国内加总
////                    stocksCopy.setGnjz(stockNumAll);
//                    log.info("***【060暂存仓】数据到这！***");
//                }

                stocksCopyMapper.update(null,updateWrapper);

                QueryWrapper queryWrapperUP = new QueryWrapper();
                queryWrapperUP.eq("goods_no",wpid);

                //查询展示表中该物品的所有库存数量
                //奇门菜鸟仓数量
                float qmcncNum = stocksCopyMapper.selectOne(queryWrapperUP).getQmcncNum();
                System.out.println("奇门菜鸟仓数量：" + qmcncNum);
                //天猫仓数量
                float tmcNum = stocksCopyMapper.selectOne(queryWrapperUP).getTmcNum();
                System.out.println("天猫仓数量：" + tmcNum);
                //网红仓数量
                float whcNum = stocksCopyMapper.selectOne(queryWrapperUP).getWhcNum();
                System.out.println("网红仓数量：" + whcNum);
                //分销仓数量
                float fxcNum = stocksCopyMapper.selectOne(queryWrapperUP).getFxcNum();
                System.out.println("分销仓数量：" + fxcNum);
                //备用仓数量
                float bycNum = stocksCopyMapper.selectOne(queryWrapperUP).getBycNum();
                System.out.println("备用仓数量：" + bycNum);
//                //次品仓数量
//                float cpcNum = stocksCopyMapper.selectOne(queryWrapperUP).getCpcNum();
//                System.out.println("次品仓数量：" + cpcNum);
//                //徐汇仓数量
//                float xhcNum = stocksCopyMapper.selectOne(queryWrapperUP).getXhcNum();
//                System.out.println("徐汇仓数量：" + xhcNum);
                //广州仓数量
                float gzcNum = stocksCopyMapper.selectOne(queryWrapperUP).getGzcNum();
                System.out.println("广州仓数量：" + gzcNum);
                //直营仓数量
                float zycNum = stocksCopyMapper.selectOne(queryWrapperUP).getZycNum();
                System.out.println("直营仓数量：" + zycNum);
//                //广州次品仓数量
//                float gzcpcNum = stocksCopyMapper.selectOne(queryWrapperUP).getGzcpcNum();
//                System.out.println("广州次品仓数量：" + gzcpcNum);
//                //暂存仓数量
//                float zccNum = stocksCopyMapper.selectOne(queryWrapperUP).getZccNum();
//                System.out.println("暂存仓数量：" + zccNum);

                //展示表已存在该物品时，插入库存前查询展示表各仓库总数
                float stockNumAll = qmcncNum + tmcNum + whcNum + fxcNum + bycNum + gzcNum + zycNum;
                System.out.println("展示表已存在该物品时，插入库存前查询展示表各仓库总数：" + stockNumAll);

                //国内加总
                updateWrapper.set("gnjz",stockNumAll);
                stocksCopyMapper.update(null,updateWrapper);
            }

        }

        log.info("======&&&&&&******【展示表数据同步结束】******&&&&&&======");
        return "旺店通库存信息表同步展示表成功！";
    }

    //获取旺店通库存信息，并同步至宜搭
    public static com.aliyun.dingtalkyida_1_0.Client createClient() throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config();
        config.protocol = "https";
        config.regionId = "central";
        return new com.aliyun.dingtalkyida_1_0.Client(config);
    }

    @Override
    public String createWangdiantongStocks(){

        //本月剩余天数
        Calendar calendar = Calendar.getInstance(TimeZone.getTimeZone("GMT+08:OO"));
        int days = calendar.get(Calendar.DAY_OF_MONTH);
        System.out.println("本月当前天数：" + days);
        int MaxDays = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
        System.out.println("本月最大天数：" + MaxDays);
        //+1的目的是为了将当天也包含在本月剩余天数中
        int bysyts = MaxDays - days + 1;
        System.out.println("本月剩余天数：" + bysyts);

        //下月总天数
        calendar.add(Calendar.MONTH,+1);//下个月
        int xyzts = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
        System.out.println("下月总天数：" + xyzts);

        //当前时间的时间戳
        long timeMillis = System.currentTimeMillis();

        //展示表
        List<StocksCopy> stocksCopyList = stocksCopyMapper.selectList(null);
        System.out.println("展示表总数：" + stocksCopyList.size());

        for (int i = 0; i < stocksCopyList.size(); i++) {
            //条形码
            String barcode = stocksCopyList.get(i).getBarcode();
            //产品编号
            String goodsNo = stocksCopyList.get(i).getGoodsNo();
            //商品名称
            String goodsName = stocksCopyList.get(i).getGoodsName();
            //国内加总
            float gnjz = stocksCopyList.get(i).getGnjz();
            //奇门菜鸟仓048
            float qmcncNum = stocksCopyList.get(i).getQmcncNum();
            //天猫仓020
            float tmcNum = stocksCopyList.get(i).getTmcNum();
            //网红仓021
            float whcNum = stocksCopyList.get(i).getWhcNum();
            //分销仓022
            float fxcNum = stocksCopyList.get(i).getFxcNum();
            //备用仓023
            float bycNum = stocksCopyList.get(i).getBycNum();
//            //次品仓024
//            float cpcNum = stocksCopyList.get(i).getCpcNum();
//            //徐汇仓025
//            float xhcNum = stocksCopyList.get(i).getXhcNum();
            //广州仓026
            float gzcNum = stocksCopyList.get(i).getGzcNum();
            //直营仓033
            float zycNum = stocksCopyList.get(i).getZycNum();
//            //广州次品仓059
//            float gzcpcNum = stocksCopyList.get(i).getGzcpcNum();
//            //暂存仓060
//            float zccNum = stocksCopyList.get(i).getZccNum();

//            //本月剩余天数（包含今日）
//            int bysyts = stocksCopyList.get(i).getBysyts();
//            //下月总天数
//            int xyzts = stocksCopyList.get(i).getXyzts();

            /*同步至宜搭*/
            Map map = new HashMap();
            //条形码
            map.put("textField_lbajxvt9", barcode);
            //产品编码
            map.put("textField_lbd4c51m", goodsNo);
            //商品名称
            map.put("textField_lbd4c51n", goodsName);
            //国内加总
            map.put("numberField_lbd9y20d", gnjz);

            //奇门菜鸟仓048
            map.put("numberField_lco5yzqv", qmcncNum);
            //天猫仓020
            map.put("numberField_lbd9y20g", tmcNum);
            //网红仓021
            map.put("numberField_lbd9y20i", whcNum);
            //分销仓022
            map.put("numberField_lbd9y20j", fxcNum);
            //备用仓023
            map.put("numberField_lbd9y20k", bycNum);
//            //次品仓024
//            map.put("numberField_lbd9y20l", cpcNum);
//            //徐汇仓025
//            map.put("numberField_lbd9y20f", xhcNum);
            //广州仓026
            map.put("numberField_lbd9y20m", gzcNum);
            //直营仓033
            map.put("numberField_lbd9y20h", zycNum);
//            //广州次品仓059
//            map.put("numberField_lbg9y9zx", gzcpcNum);
//            //暂存仓060
//            map.put("numberField_lbg9ya00", zccNum);

            //数据更新日期（时间戳）
            map.put("dateField_lbg3bsyh", timeMillis);
            //本月剩余天数（包含今日）
            map.put("numberField_lbg3bsyf", bysyts);
            //下月总天数
            map.put("numberField_lbg3bsyg", xyzts);

            String mapJson = JSON.toJSONString(map);
            System.out.println("mapJson：" + mapJson);

            //宜搭表单判断查询条件
            Map map1 = new HashMap();
            //产品编号
            map1.put("key","textField_lbd4c51m");
            //产品编号查询匹配值
            map1.put("value",goodsNo);
            //控件编号（文本）
            map1.put("type","TEXT");
            //逻辑判断符
            map1.put("operator","eq");
            //控件类型（文本）
            map1.put("componentName","TextField");
            List list = new ArrayList();
            list.add(map1);

            String listJson = JSON.toJSONString(list);
            System.out.println("查询条件listJson：" + listJson);


            //新增或更新表单实例【宜搭】
            try {
                com.aliyun.dingtalkyida_1_0.Client client = createClient();
                com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataHeaders createOrUpdateFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataHeaders();
                createOrUpdateFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
                com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataRequest createOrUpdateFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.CreateOrUpdateFormDataRequest()
                        .setSystemToken("DJ966581GT76IWY6660IB9E1MIP62BYAXJABL1OB")
                        .setFormUuid("FORM-BH766Y61VAO5U4ZV775ZG679JWIQ2A6MXJABLQ3")
                        .setUserId("yida_pub_account")
                        .setSearchCondition(listJson)
                        .setAppType("APP_R1OQTHQK87Q5S5ZSSYC1")
                        .setFormDataJson(mapJson);

                client.createOrUpdateFormDataWithOptions(createOrUpdateFormDataRequest, createOrUpdateFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
            } catch (TeaException err) {
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            } catch (Exception _err) {
                TeaException err = new TeaException(_err.getMessage(), _err);
                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
                    // err 中含有 code 和 message 属性，可帮助开发定位问题
                }

            }

            //创建宜搭表单数据
//            try {
//                com.aliyun.dingtalkyida_1_0.Client client = createClient();
//                com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders saveFormDataHeaders = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataHeaders();
//                saveFormDataHeaders.xAcsDingtalkAccessToken = accessTokenService.getAccessToken();
//                com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest saveFormDataRequest = new com.aliyun.dingtalkyida_1_0.models.SaveFormDataRequest()
//                        //宜搭应用秘钥
//                        .setSystemToken("DJ966581GT76IWY6660IB9E1MIP62BYAXJABL1OB")
//                        //宜搭表单ID
//                        .setFormUuid("FORM-BH766Y61VAO5U4ZV775ZG679JWIQ2A6MXJABLQ3")
//                        //创建人id
//                        .setUserId("yida_pub_account")
//                        //宜搭应用编码
//                        .setAppType("APP_R1OQTHQK87Q5S5ZSSYC1")
//                        .setFormDataJson(mapJson);
//
//                client.saveFormDataWithOptions(saveFormDataRequest, saveFormDataHeaders, new com.aliyun.teautil.models.RuntimeOptions());
//            } catch (TeaException err) {
//                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
//                    // err 中含有 code 和 message 属性，可帮助开发定位问题
//                }
//
//            } catch (Exception _err) {
//                TeaException err = new TeaException(_err.getMessage(), _err);
//                if (!com.aliyun.teautil.Common.empty(err.code) && !com.aliyun.teautil.Common.empty(err.message)) {
//                    // err 中含有 code 和 message 属性，可帮助开发定位问题
//                }
//
//            }
        }


        log.info("======数据同步结束======");
        return "同步至宜搭库存信息表成功！";
    }
}
